package org.siqisource.agave.test;

import java.lang.reflect.Field;
import java.util.List;

import org.junit.Assert;

public class AgaveAssert extends Assert {

	public static void assertEquals(Object expected, Object actual) {
		try {
			String failMessage = AgaveAssert.getMessage(expected, actual, -1);
			if (!"".equals(failMessage.toString().trim())) {
				Assert.fail(failMessage.toString());
			}
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
	}

	public static void assertEquals(List<?> expecteds, List<?> actuals) {
		StringBuffer failMessage = new StringBuffer();
		try {
			if (expecteds.size() != actuals.size()) {
				failMessage.append("row count expected:<[").append(expecteds.size()).append("]> but was:<[").append(actuals.size()).append("]>");
			} else {
				for (int i = 0, iSize = expecteds.size(); i < iSize; i++) {
					failMessage.append(AgaveAssert.getMessage(expecteds.get(i), actuals.get(i), i));
				}
			}
			if (!"".equals(failMessage.toString().trim())) {
				Assert.fail(failMessage.toString());
			}
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
	}

	public static String getMessage(Object expected, Object actual, int row) throws IllegalArgumentException, IllegalAccessException {
		StringBuffer message = new StringBuffer();
		String rowInfo = row < 0 ? "" : "row=" + row + ",";
		Field[] expectedFields = expected.getClass().getDeclaredFields();
		Field[] actualFields = actual.getClass().getDeclaredFields();

		if (expectedFields.length != actualFields.length) {
			message.append("column count expected:<[").append(expectedFields.length).append("]>");
			message.append(" but was:<[").append(actualFields.length).append("]>");
		} else {
			String columnName = "";
			String expectedValue = "";
			String actualValue = "";
			for (int i = 0; i < expectedFields.length; i++) {
				columnName = Converter.propertyToColumn(expectedFields[i].getName());
				expectedFields[i].setAccessible(true);
				actualFields[i].setAccessible(true);
				expectedValue = Converter.objectToString(expectedFields[i].get(expected));
				actualValue = Converter.objectToString(actualFields[i].get(actual));
				if (!expectedValue.equals(actualValue)) {
					message.append("\r\n value (").append(rowInfo).append(" col=").append(columnName).append(") expected:<[").append(expectedValue);
					message.append("]> but was:<[").append(actualValue).append("]>");
				}
			}
		}
		return message.toString();
	}
}
