package org.siqisource.agave.test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Converter {

	public static String propertyToColumn(String property) {
		if (null == property) {
			return "";
		}
		char[] chars = property.toCharArray();
		StringBuffer field = new StringBuffer();
		for (char c : chars) {
			if (Character.isUpperCase(c)) {
				field.append("_");
			}
			field.append(Character.toLowerCase(c));
		}
		return field.toString().toLowerCase();
	}

	public static String columnToProperty(String column) {
		String[] words = column.toLowerCase().split("_");
		StringBuffer property = new StringBuffer();

		for (int i = 0; i < words.length; i++) {
			String word = words[i];
			if (i == 0) {
				property.append(word);
			} else {
				property.append(Character.toUpperCase(word.charAt(0)));
				property.append(word.substring(1));
			}
		}
		return property.toString();
	}

	public static String getFirstUpperProperty(String column) {
		String property = Converter.columnToProperty(column);
		return property.substring(0, 1).toUpperCase() + property.substring(1);
	}

	public static String objectToString(Object data) {
		return data == null ? "" : data.toString();
	}

	public static Object valueTransform(String columnType, String value) {
		if ("java.lang.String".equals(columnType)) {
			return value;
		} else if ("int".equals(columnType)) {
			return Integer.parseInt(value);
		} else if ("double".equals(columnType)) {
			return Double.valueOf(value);
		} else if ("float".equals(columnType)) {
			return Float.valueOf(value);
		} else if ("boolean".equals(columnType)) {
			return "true".equals(value);
		} else if ("java.util.Date".equals(columnType)) {
			return Converter.parseDate(value);
		} else {
			return null;
		}
	}

	public static Date parseDate(String dateStr) {
		Date date = null;
		if (!"".equals(dateStr)) {
			try {
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				date = sdf.parse(dateStr.toString());
			} catch (ParseException e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}
		return date;
	}
}
